//========= Copyright  1996-2001, Valve LLC, All rights reserved. ============
//
// Purpose: 
//
// $NoKeywords: $
//=============================================================================

// Triangle rendering, if any

#include "hud.h"
#include "cl_util.h"

// Triangle rendering apis are in gEngfuncs.pTriAPI

#include "const.h"
#include "entity_state.h"
#include "cl_entity.h"
#include "triangleapi.h"

//#include "event_api.h"

#define DLLEXPORT __declspec( dllexport )

extern "C"
{
	void DLLEXPORT HUD_DrawNormalTriangles( void );
	void DLLEXPORT HUD_DrawTransparentTriangles( void );
};


/*
=================
Draw_Triangles

Example routine.  Draws a sprite offset from the player origin.
=================
*/


void Draw_Numbers( int numeral, float x )
{
        cl_entity_t *player, *localplayer;
        vec3_t org;
        vec3_t Point;
        vec3_t ang;


	// Load it up with some bogus data
        player = gEngfuncs.GetLocalPlayer();
        if ( !player )
                return;


        //THANK GOODNESS FOR THE FRENCH


        //gEngfuncs.pEventAPI->EV_LocalPlayerViewheight( (float *)ang );
        gEngfuncs.GetViewAngles( (float *)ang );
        Vector fwd,right,up; 
        AngleVectors( ang, fwd, right, up );

        org = player->origin;
        org.z += 28;
        org = org + (5 * fwd);


        if (gHUD.m_hsprCursor == 0)
        {
                char hz[256];
                sprintf( hz, "sprites/white.spr" );
                gHUD.m_hsprCursor = SPR_Load( hz );
        }

        if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))
                return;


        gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
        gEngfuncs.pTriAPI->CullFace( TRI_NONE );
        gEngfuncs.pTriAPI->Color4f( 1.0, 0.6, 0.0, 1 );
        gEngfuncs.pTriAPI->Brightness( 1 );


        org = org + (-4.4 * right) + (-1.3 * up);
        org = org + (x * right);


     //bc this is my triapi draw-number code.
     // "numeral" is the number that it prints.
     //default org spot = lower lefthand corner of number.
        switch ( numeral )
        {
        default:
        case 0:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 1:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.2 * up) + (0.1 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 2:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * right) + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right) + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 3:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * right) + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 4:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * right) + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 5:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 6:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * right)  + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 7:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 8:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        case 9:
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//top horiz bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//left vert bar
                        Point = org + (0.2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//right vert bar
                        Point = org + (0.2 * up) + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//bottom horiz bar
                        Point = org;
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        break;
        }
}







void Draw_Triangles( void )
{
        cl_entity_t *player, *localplayer;
        vec3_t org;
        vec3_t Point;
        vec3_t ang;


	// Load it up with some bogus data
        player = gEngfuncs.GetLocalPlayer();
        if ( !player )
                return;


        //THANK GOODNESS FOR THE FRENCH


        //gEngfuncs.pEventAPI->EV_LocalPlayerViewheight( (float *)ang );
        gEngfuncs.GetViewAngles( (float *)ang );
        Vector fwd,right,up; 
        AngleVectors( ang, fwd, right, up );

        org = player->origin;
        org.z += 28;
        org = org + (5 * fwd);


        if (gHUD.m_hsprCursor == 0)
        {
                char hz[256];
                sprintf( hz, "sprites/white.spr" );
                gHUD.m_hsprCursor = SPR_Load( hz );
        }

        if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprCursor ), 0 ))
                return;


        gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
        gEngfuncs.pTriAPI->CullFace( TRI_NONE );
        gEngfuncs.pTriAPI->Color4f( 1.0, 0.6, 0.0, 1 );
        gEngfuncs.pTriAPI->Brightness( 1 );


        //=========MAIN CROSSHAIR
        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (-2 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (-0.1 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (-0.1 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (-0.1 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (0.1 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (-0.1 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (-0.1 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (0.1 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (0.1 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (0.1 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (0.1 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (2 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();


        //=========VERTICAL HAIRS
        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (-0.6 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (-1 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (0.6 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (1 * up);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();



        //gHUD.m_Health.m_iHealth

        if (gHUD.m_Battery.m_iBat > 65)
        {
        //========= DRAW HEAT WARNING ===================

        //===== HHHHHHHHHH
                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.1 * up) + (1 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        
                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.1 * up) + (1.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        
                gEngfuncs.pTriAPI->Begin( TRI_LINES );//middle horiz bar
                        Point = org + (0.2 * up) + (1 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (1.2 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

        //===== EEEEEEE
                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.1 * up) + (1.25 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1.25 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.3 * up) + (1.25 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1.45 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.2 * up) + (1.25 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (1.45 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.1 * up) + (1.25 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (1.45 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

        //===== AAAAAAA
                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.1 * up) + (1.5 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (1.5 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.1 * up) + (1.7 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (1.7 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.2 * up) + (1.5 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.2 * up) + (1.7 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.2 * up) + (1.5 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1.6 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.2 * up) + (1.7 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1.6 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

        //===== TTTTTTTT
                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.3 * up) + (1.75 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.3 * up) + (1.95 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();

                gEngfuncs.pTriAPI->Begin( TRI_LINES );
                        Point = org + (0.3 * up) + (1.85 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                        Point = org + (0.1 * up) + (1.85 * right);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->End();
        }


        //===========DRAW THERMOMETER FRAME
        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (1.35 * up) + (2.55 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (-1.35 * up) + (2.55 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (1.35 * up) + (2.4 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (1.35 * up) + (3 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (-1.35 * up) + (2.4 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (-1.35 * up) + (3 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        gEngfuncs.pTriAPI->Begin( TRI_LINES );
                Point = org + (0 * up) + (2.4 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                Point = org + (0 * up) + (2.55 * right);
                gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();




        //===========DRAW HEAT TEMPERATURE
        float HealthHeight;
        HealthHeight = (gHUD.m_Battery.m_iBat / 38.46);

        if (gHUD.m_Battery.m_iBat > 65)
                gEngfuncs.pTriAPI->Color4f( 1.0, 0.0, 0.0, 1 );
        else
                gEngfuncs.pTriAPI->Color4f( 1.0, 0.6, 0.0, 1 );

	gEngfuncs.pTriAPI->Begin( TRI_QUADS );
                gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
                Point = org + (2.6 * right) + ((-1.3 + HealthHeight) * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
                Point = org + (2.6 * right) + (-1.3 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
                Point = org + (3 * right) + (-1.3 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
                Point = org + (3 * right) + ((-1.3 + HealthHeight) * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
	gEngfuncs.pTriAPI->End();


        gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
}

void Draw_Health( void )
{
        cl_entity_t *player, *localplayer;
        vec3_t org;
        vec3_t Point;
        vec3_t ang;


	// Load it up with some bogus data
        player = gEngfuncs.GetLocalPlayer();
        if ( !player )
                return;


        //THANK GOODNESS FOR THE FRENCH


        //gEngfuncs.pEventAPI->EV_LocalPlayerViewheight( (float *)ang );
        gEngfuncs.GetViewAngles( (float *)ang );
        Vector fwd,right,up; 
        AngleVectors( ang, fwd, right, up );

        org = player->origin;
        org.z += 28;
        org = org + (7 * fwd);


        //if (gHUD.m_hsprhealth == 0)
        {
                char hz[256];
                sprintf( hz, "sprites/mechpic.spr" );
                gHUD.m_hsprhealth = SPR_Load( hz );
        }
        
        if ( !gEngfuncs.pTriAPI->SpriteTexture( (struct model_s *)gEngfuncs.GetSpritePointer( gHUD.m_hsprhealth ), 0 ))
                return;
          

        gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
        gEngfuncs.pTriAPI->CullFace( TRI_NONE );

        gEngfuncs.pTriAPI->Color4f( 1.0, 0.0, 0.0, 1.0 );

        // ==============redbar mechpic
        float myhealth = -5 + (((100 - gHUD.m_Health.m_iHealth) * 0.01) * 3.0);
        float healthtex = (gHUD.m_Health.m_iHealth) / 100.0;

        if (healthtex < 0)
                healthtex = 0;

	gEngfuncs.pTriAPI->Begin( TRI_QUADS );
                gEngfuncs.pTriAPI->TexCoord2f( 0, healthtex );
                Point = org + (-7 * right) + (myhealth * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
                Point = org + (-7 * right) + (-5 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
                Point = org + (-4 * right) + (-5 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 1, healthtex );
                Point = org + (-4 * right) + (myhealth * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

        //====== mech pic
        gEngfuncs.pTriAPI->Color4f( 1.0, 0.6, 0.0, 0.3 );
	gEngfuncs.pTriAPI->Begin( TRI_QUADS );
                gEngfuncs.pTriAPI->TexCoord2f( 0, 0 );
                Point = org + (-7 * right) + (-2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 0, 1 );
                Point = org + (-7 * right) + (-5 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 1, 1 );
                Point = org + (-4 * right) + (-5 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
                gEngfuncs.pTriAPI->TexCoord2f( 1, 0 );
                Point = org + (-4 * right) + (-2 * up);
                        gEngfuncs.pTriAPI->Vertex3f( Point.x, Point.y, Point.z );
        gEngfuncs.pTriAPI->End();

//bc
        int k;
        float x;
        float iWidth;

        x = 0;
        iWidth = 0.3;

        if ( gHUD.m_Health.m_iHealth > 0)
	{
		// SPR_Draw 100's
                if (gHUD.m_Health.m_iHealth >= 100)
		{
                        k = gHUD.m_Health.m_iHealth/100;
                        Draw_Numbers( k, x );
                        x += iWidth;
		}
                else
                {
                        Draw_Numbers( 0, x );
                        x += iWidth;
                }

		// SPR_Draw 10's
                if (gHUD.m_Health.m_iHealth >= 10)
		{
                        k = (gHUD.m_Health.m_iHealth % 100)/10;
                        Draw_Numbers( k, x );
                        x += iWidth;
		}
                else
                {
                        Draw_Numbers( 0, x );
                        x += iWidth;
                }

		// SPR_Draw ones
                k = gHUD.m_Health.m_iHealth % 10;
                Draw_Numbers( k, x );
        }







//        gEngfuncs.pTriAPI->RenderMode( kRenderTransAdd );
}










/*
=================
HUD_DrawNormalTriangles

Non-transparent triangles-- add them here
=================
*/
void DLLEXPORT HUD_DrawNormalTriangles( void )
{
//      Draw_Triangles();
}

/*
=================
HUD_DrawTransparentTriangles

Render any triangles with transparent rendermode needs here
=================
*/
void DLLEXPORT HUD_DrawTransparentTriangles( void )
{
      Draw_Triangles();
      Draw_Health();
}
